(in-package :cl-user)

(defclass bob ()
  ((a-slot :accessor bob.a :initform nil)))

(defun bob-calls (times bob-obj value)
  (dotimes (i times)
    (setf (bob.a bob-obj) value)))

(defun slot-bob-calls (times slot bob-obj value)
  (dotimes (i times)
    (setf (slot-value bob-obj slot) value)))

(defvar *hashed-eq* (make-hash-table :test #'eq))
(defvar *hashed-eql* (make-hash-table :test #'eql))
(defvar *hashed-equal* (make-hash-table :test #'equal))

(defun eq-calls (times key value)
  (let ((table *hashed-eq*))
    (dotimes (i times)
      (setf (gethash key table) value))))

(defun eql-calls (times key value)
  (let ((table *hashed-eql*))
    (dotimes (i times)
      (setf (gethash key table) value))))

(defun equal-calls (times key value)
  (let ((table *hashed-equal*))
    (dotimes (i times)
      (setf (gethash key table) value))))
