(in-package :cl-user)

(compile-file "meth-vs-hash.lisp")
(load "meth-vs-hash")

(defun fill-eq-table (number)
  (let ((table *hashed-eq*))
    (dotimes (i number)
      (setf (gethash (make-symbol (format nil "~a" i)) table) i))))

(defun fill-eql-table (number)
  (let ((table *hashed-eql*))
    (dotimes (i number)
      (setf (gethash i table) i))))

(defun fill-equal-table (number)
  (let ((table *hashed-equal*))
    (dotimes (i number)
      (setf (gethash (format nil "~a" i) table) i))))

    
(defun my-tests (times)
  (let ((bob-obj (make-instance 'bob))
	(the-value (cons 67 76)))

    (format t "~&--------------------------------------------------------------~2%")
    (format t "~&SLOT-SETTING TEST on ~a ~a~%"
	    (lisp-implementation-type) (lisp-implementation-version))
    (format t "~&Setting via an accessor [~a accesses]:~%" times)
    (time (bob-calls times bob-obj the-value))
    (format t "~&Setting via SLOT-VALUE [~a accesses]:~%" times)
    (time (slot-bob-calls times 'a-slot bob-obj the-value))
    (format t "~&Setting in EQ-table [~a accesses](~a objs already in table):~%"
	    times (hash-table-count *hashed-eq*))
    (time (eq-calls times :42 the-value))
    (format t "~&Setting in EQL-table [~a accesses](~s objs already in table):~%"
	    times (hash-table-count *hashed-eql*))
    (time (eql-calls times 42 the-value))
    (format t "~&Setting in EQUAL-table [~a accesses](~s objs already in table):~%"
	    times (hash-table-count *hashed-eql*))
    (time (equal-calls times "42" the-value))
    (format t "~&--------------------------------------------------------------~2%")
    ))

(compile 'my-tests)

(fill-eq-table 10000)
(fill-eql-table 10000)
(fill-equal-table 10000)

(ext:gc)

(my-tests 1000000)

#+cmu
(when ext:*batch-mode*
  (cl-user::quit))
